"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}Object.defineProperty(exports,"__esModule",{value:!0});var React=require("react"),React__default=_interopDefault(React),isEqual=_interopDefault(require("fast-deep-equal")),invariant=_interopDefault(require("invariant")),FormContext=React.createContext(null);const FormRefContext=React.createContext(null),FormControllerContext=React.createContext(null),cloneObject=function(e){let r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};return Object.assign({},e,r)},newObject=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};for(var r=arguments.length,t=new Array(r>1?r-1:0),o=1;o<r;o++)t[o-1]=arguments[o];return 0===t.length?cloneObject(e):t.reduce((r,t)=>cloneObject(r,"function"==typeof t&&t(e,r)||t),cloneObject(e))},TYPE_NULL="null",TYPE_UNDEFINED="undefined",TYPE_STRING="string",TYPE_ARRAY="array",TYPE_BOOLEAN="boolean",TYPE_OBJECT="object",TYPE_FUNCTION="function",TYPE_ERROR="error",TYPE_SYMBOL="symbol",TYPE_GENERATOR_FUNCTION="generatorFunction",type={"[object Null]":"null","[object Undefined]":"undefined","[object String]":"string","[object Array]":"array","[object Boolean]":"boolean","[object Object]":"object","[object Function]":"function","[object Error]":"error","[object Symbol]":"symbol","[object GeneratorFunction]":"generatorFunction"},typeOf=e=>void 0===e?typeof e:type[Object.prototype.toString.call(e)]||typeof e,_uniqueId={},generateTimeStamp=()=>(new Date).getTime(),generateUniqueId=function e(){const r=Math.floor(Math.random()*generateTimeStamp());return _uniqueId[r]?e():(_uniqueId[r]=r,r)},deleteUniqueId=e=>delete _uniqueId[e],IS_SCHEMA=`_schema_id_@_${generateTimeStamp()}_@_`,IS_FORMREF=`${IS_SCHEMA}_ref`,IS_MULTIPLE=`${IS_SCHEMA}_multiple`,PRIMITIVE_VALUE=`${IS_SCHEMA}_primitive_@_`,SCHEMA_CONFIG=`${IS_SCHEMA}_config`,ON_CHANGE="onChange",ON_BLUR="onBlur",VALUE="value",ERROR="error",_getPlatformBasedFieldValue=e=>e&&"object"==typeof e&&e.target&&"function"==typeof e.preventDefault?e.target.value:e,_getPlatformBasedFieldName=e=>e&&"object"==typeof e&&e.target&&"function"==typeof e.preventDefault?e.target.name:void 0,_checkType=(e,r)=>newObject("function"==typeof e?e(r):e),_trimStrings=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:"",r=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(e&&"string"==typeof e&&String(e)){const t=String(e).trim();return r?Number(t):t}return e},_setInitialValues=e=>{let{formConfig:r,initialValues:t={},formRef:o,isMultiple:n,isError:i}=e;const a=e=>{const o=r[e]||{};return e in t?"function"==typeof t[e]?t[e]():t[e]:"default"in o?o.default:""},u=(n&&Array.isArray(t)?t:[t]).reduce((e,t)=>{if(r[IS_MULTIPLE])return[];const u=Object.entries(r||{}).reduce((e,r)=>{let[n,u={}]=r;return newObject(e,n in t?{[n]:u&&(u[IS_SCHEMA]||u[IS_MULTIPLE]||u._formId_)?_setInitialValues({formRef:u._formId_?u:o&&o.current&&o.current._schema[n].formRef,initialValues:t[n]||{},formConfig:u._formId_?u.getFormConfig():u[SCHEMA_CONFIG],isMultiple:u[IS_MULTIPLE],isError:i}):i?t[n]||null:a(n)}:{[n]:i?t[n]||null:a(n)})},{});return n?e.concat([u]):u},n?[]:{});return o&&o.current&&(o.current[i?"errors":"values"]=u),u},_setInitialErrors=e=>_setInitialValues({...e,isError:!0});function _deepCopy(e,r,t){if(null===e||"object"!=typeof e)return e;if("function"==typeof e.clone)return e.clone(!0);if(e instanceof Date)return new Date(e.getTime());if(e instanceof RegExp)return new RegExp(e);if(e.nodeType&&"function"==typeof e.cloneNode)return e.cloneNode(!0);void 0===r&&(r=[],t=[]);var o=r.length;for(i=0;i<o;i++)if(e===r[i])return t[i];if("[object Array]"==Object.prototype.toString.call(e)){var n=e.slice();r.push(e),t.push(n);for(var i=n.length;i--;)n[i]=_deepCopy(n[i],r,t);return n}var a=Object.getPrototypeOf?Object.getPrototypeOf(e):e.__proto__;a||(a=e.constructor.prototype);var u=Object.create(a);for(var c in r.push(e),t.push(u),e)u[c]=_deepCopy(e[c],r,t);return u}const checkKey=(e,r,t)=>{const o=Array.isArray(t)?t:[t];invariant(o.includes(typeOf(e)),r)},checkIsValidConfig=e=>e[IS_SCHEMA]||e[IS_MULTIPLE],newSchema=e=>(checkIsValidConfig(e||{})&&checkKey(!1,"(newSchema) Invalid form schema","object"),{[IS_SCHEMA]:!0,[SCHEMA_CONFIG]:e}),newFormArray=e=>(e[IS_MULTIPLE]&&checkKey(!1,"(newMultiple) Invalid form schema","object"),{[IS_MULTIPLE]:!0,[SCHEMA_CONFIG]:e[IS_SCHEMA]?e._config:e}),TYPE_STRING$1="string",TYPE_ARRAY$1="array",TYPE_OBJECT$1="object",TYPE_FUNCTION$1="function",ID_KEY="id";var useConsumerHook=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};const r=React.useRef({}),{inputProps:t={},idKey:o,onSubmit:n,setInputProps:i,extraProps:a}=React.useContext(FormContext)||{},{render:u,inputConfig:c,...f}=React.useContext(FormControllerContext)||{},l={...e.inputConfig,...c},{formRef:s,renderForm:m}=React.useContext(FormRefContext)||{};let _=t[e[o||"id"]]||{};_._fieldConfig&&!isEqual(r.current.inputConfig,l)&&(r.current.inputConfig&&Object.keys(r.current.inputConfig).forEach(e=>{let[r,t]=e;delete _._fieldConfig[r]}),_._fieldConfig._initiated=!0,"object"===typeOf(l)&&Object.entries(l).forEach(e=>{let[r,t]=e;void 0!==t&&(_._fieldConfig[r]=t)}),s.setFormConfig({...s.getFormConfig(),[e[o||"id"]]:newObject(_._fieldConfig||{},{_initiated:!0,render:!!(void 0!==l.render?l.render:void 0!==u?u:m||u)})},[e[o||"id"]],!1),s._renderForm(!0));const d=s.getInputProps(a);if(!(e[o||"id"]in d||r.current.id)){if(r.current.id=e[o||"id"],PRIMITIVE_VALUE in d)throw new Error(`Invalid: "${e[o||"id"]}" cannot add any field to literal value `);s.modifyFormConfig({[e[o||"id"]]:newObject(l||{},{_initiated:!0,render:!!(void 0!==l.render?l.render:m||u)})}),s._setInputProps(),s._renderForm(),s.renderForm()}React.useEffect(()=>(i(),()=>{_._fieldConfig&&(_._fieldConfig._initiated=!1,"object"===typeOf(l)&&Object.keys(l).forEach(e=>{_._fieldConfig[e]=_._defaultConfig[e]})),r.current.id&&t[IS_SCHEMA].deleteFormConfig([r.current.id]),t[IS_SCHEMA].resetFormInput([e[o||"id"]],!!r.current.id),t[IS_SCHEMA].onFormChangeCallback()}),[s._formId_]),r.current.inputConfig=l,_.error&&_[IS_SCHEMA].validateField(void 0===_.value?"":_.value);const p=s.getInputProps(a)[e[o||"id"]]||{};return{inputProps:{...p.inputProps||{},...f},_inputFieldConfig:p._config,...n?{onSubmit:n}:{}}};const Consumer=React.memo(e=>{let{children:r,...t}=e;return"function"==typeof r?r(t):r},(e,r)=>e.inputProps.value===r.inputProps.value&&e.inputProps.error===r.inputProps.error&&(e._inputFieldConfig&&e._inputFieldConfig._config.lastUpdated)===(r._inputFieldConfig&&r._inputFieldConfig._config.lastUpdated));var FormConsumer=e=>{let{children:r,...t}=e;return React__default.createElement(Consumer,useConsumerHook(t),r)};const getFormRef=(e,r)=>{let t=e;return t._isSchema_or_isMultiple_config_is_root&&(t=t._schema[t._isSchema_or_isMultiple_config_is_root].formRef),t=r?t&&t._schema[r]&&t._schema[r].formRef:t},checkFormRefIsValid=e=>{if(!e||"FormRef"!==e.constructor.name)throw new Error("Invalid FormRef")};var FormProvider=React.forwardRef((e,r)=>{let{children:t,idKey:o,onSubmit:n,formRef:i,extraProps:a,id:u,renderForm:c}=e;if(!i&&!u||i&&"FormRef"!==i.constructor.name)throw i?new Error("Invalid FormRef"):new Error("Required props 'formRef' or 'id' ");const{formRef:f,renderForm:l,setRefresh:s,rootFormRef:m}=React.useContext(FormRefContext)||{},_=React.useRef({}),[d,p]=React.useState(),{extraProps:g={}}=React.useContext(FormContext)||{},I=newObject(g,a),R=m||i;let F;F=(e=>{s&&s(e),p(e)}),_.current.__setRefresh=F;const E=void 0!==c?c:l,C=React.useRef({});let h=i||f;checkFormRefIsValid(h);let y=getFormRef(h,u);if(!y&&u){checkFormRefIsValid(h),C.current.id=u;let e=h.modifyFormConfig({[u]:newSchema({})}),r=getFormRef(h=e,u);y=r}checkFormRefIsValid(y),y._setRenderForm||(y._ref(IS_FORMREF)._setRenderForm=h._setRenderForm);const[v,S]=React.useState(()=>y&&y.getInputProps(I));return React.useEffect(()=>{S(y&&y.getInputProps(I))},[y._formId_]),y&&y._formId_&&(y._ref(IS_FORMREF)._setInputProps=f?e=>{f._renderInputProps&&f._renderInputProps(),S(e)}:S),React.useEffect(()=>()=>{y&&y._ref(IS_FORMREF)._setInputProps&&delete y._ref(IS_FORMREF)._setInputProps,y&&y._ref(IS_FORMREF)._extraProps&&delete y._ref(IS_FORMREF)._extraProps},[y._formId_]),React.useEffect(()=>()=>{C.current.id&&(h.deleteFormConfig([C.current.id]),_.current.__setRefresh({}))},[h._formId_]),y&&y._formId_&&(y._ref(IS_FORMREF)._extraProps=I),React.useEffect(()=>(y._ref(IS_FORMREF)._is_form_initiated=!0,y._renderForm(),y.renderForm(),()=>{y._ref(IS_FORMREF)._is_form_initiated=!1,y._renderForm(),y.renderForm()}),[y._formId_]),R._formRef.__formRef__.values=R._formRef.__formRef__.getValues(),R._formRef.__formRef__.errors=R._formRef.__formRef__.getErrors(),React__default.createElement(FormContext.Provider,{value:{inputProps:v,idKey:o,onSubmit:n,setInputProps:()=>S(()=>y.getInputProps(I)),formId:h._formId_,extraProps:I}},React__default.createElement(FormRefContext.Provider,{value:{formRef:y,formId:y._formId_,renderForm:E,lastUpdated:y._lastUpdated,setRefresh:F,rootFormRef:m||i}},r&&"current"in r&&(r.current=y)&&null,"function"==typeof t?t({inputProps:v,values:y.getValues(),errors:y.getErrors(),formRef:y}):t))});const convertToOriginalData=e=>"object"===typeOf(e)&&PRIMITIVE_VALUE in e?e[PRIMITIVE_VALUE]:e,generateNewFormRef=(e,r,t,o,n)=>{const i="object"===typeOf(r)||void 0===r?r:{[PRIMITIVE_VALUE]:r};return e._formValidationHandler(newObject({...newObject(e._initialConfig),FORM_CONFIG:n?newFormArray({}):newObject(e._initialConfig.FORM_CONFIG),initialState:i||{},renderFormCallback:o._setRenderForm,_rootRef:{current:o},getFormData:o._isRenderForm?t._setRenderForm:void 0}))},_getFormRef=(e,r)=>{let t=e;return t._isSchema_or_isMultiple_config_is_root&&(t=t._schema[t._isSchema_or_isMultiple_config_is_root].formRef),t=r?t&&t._schema[r]&&t._schema[r].formRef:t},checkFormRefIsValid$1=e=>{if(!e||"FormRef"!==e.constructor.name)throw new Error("Invalid FormRef")};var MultipleFormProvider=React.forwardRef((e,r)=>{let{children:t,formRef:o,noAutoLoop:n,id:i,renderForm:a,defaultCount:u=1}=e;if(!o&&!i||o&&"FormRef"!==o.constructor.name)throw o?new Error("Invalid FormRef"):new Error("Required props 'formRef' or 'id' ");const{formRef:c,setRefresh:f,renderForm:l,rootFormRef:s}=React.useContext(FormRefContext)||{},{setInputProps:m}=React.useContext(FormContext),_=React.useRef({}),d=void 0!==a?a:l,p=s||o;let g=o||c;checkFormRefIsValid$1(g);const I=_getFormRef(g,i);let R=I;if(R)I&&o&&!I._multipleConfig&&I._parentRef&&I._parentRef.modifyFormConfig({[I._parentId]:{...I._parentConfig[I._parentId],[SCHEMA_CONFIG]:newFormArray({})}});else if(i){_.current.id=i;let e=g.modifyFormConfig({[i]:newFormArray({})}),r=_getFormRef(g=e,i);R=r}checkFormRefIsValid$1(R);const F=React.useRef({}),[E,C]=React.useState();let h;h=(e=>{f&&f(e),C(e)});const[y,v]=React.useState(()=>(()=>R[IS_MULTIPLE]._initialValues.length>0?R[IS_MULTIPLE]._initialValues.map(e=>generateNewFormRef(R,e,c,p,!!c._multipleConfig)):[...Array("number"==typeof u?u:0)].map(e=>generateNewFormRef(R,e,c,p,!!c._multipleConfig)))());F.current.formRefArray=y;const S={},P=(()=>F.current.formRefArray.map((e,r)=>{let{formId:t}=e;return S[t]=r,t}))();F.current.formIds=P,F.current.formIdIndex=S;const O=React.useCallback((e,r)=>{const t=F.current.formIdIndex[e],o=F.current.formIdIndex[r];t!==o&&F.current.formRefArray.length>1&&o>=0&&o<F.current.formRefArray.length&&t>=0&&t<F.current.formRefArray.length&&v(e=>{const r=e.slice(),n=r[t];return"number"==typeof o&&"number"==typeof t&&(r.splice(t,1),r.splice(o,0,n)),r})},[]),b=React.useCallback((e,r)=>{const t=F.current.formIdIndex[e],o=F.current.formIdIndex[r];t!==o&&F.current.formRefArray.length>1&&o>=0&&o<F.current.formRefArray.length&&t>=0&&t<F.current.formRefArray.length&&v(e=>{const r=e.slice(),n=r[t],i=r[o];return console.log(r),"number"==typeof o&&"number"==typeof t&&(r.splice(t,1,i),console.log(r),r.splice(o,1,n),console.log(r)),r})},[]),M=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[];(Array.isArray(e)?e:[e]).forEach(e=>{const r=F.current.formRefArray[F.current.formIdIndex[e]];r&&r.formRef&&r.formRef.resetForm()})},A=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[];(Array.isArray(e)?e:[e]).forEach(e=>{const r=F.current.formRefArray[F.current.formIdIndex[e]];r&&r.formRef&&r.formRef.clearForm()})},L=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[],r=arguments.length>1?arguments[1]:void 0,t=arguments.length>2&&void 0!==arguments[2]?arguments[2]:1,o=arguments.length>3?arguments[3]:void 0;const n=F.current.formIdIndex[r]+(o?1:0);n>=0&&n<=F.current.formRefArray.length&&v(r=>{let o=r.slice();const i=[...Array(t)].map((r,t)=>generateNewFormRef(R,e[t],c,p));return"number"==typeof n?o.splice(n,0,...i):o.concat(i),o})},V=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[],r=arguments.length>1?arguments[1]:void 0,t=arguments.length>2?arguments[2]:void 0,o=arguments.length>3?arguments[3]:void 0;L(Array.isArray(e)?e:void 0!==e?[e]:[],r,t,o)},T=function(e){let r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1;const t=F.current.formIdIndex[e];if(t>-1&&t<F.current.formRefArray.length&&F.current.formRefArray[t]&&F.current.formRefArray[t].formRef){const o=F.current.formRefArray[t].formRef.getValues();L(Array(r).fill(o),e,r)}},j=React.useCallback(function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[];!function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[];e.length>0&&v(r=>r.slice().filter(r=>{let{formId:t}=r;return!e.includes(t)}))}(Array.isArray(e)?e:[e])},[]);r&&"current"in r&&(r.current.formArray=y);const U=React.useCallback(()=>{return F.current.formRefArray.map(e=>{let{formRef:r}=e;return convertToOriginalData(r.getValues())})},[]),N=React.useCallback(function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[],r=arguments.length>1?arguments[1]:void 0;if(!Array.isArray(e))return U();if(e.length>F.current.formRefArray.length){const r=e.slice(F.current.formRefArray.length).map(e=>generateNewFormRef(R,e,c,p));v(F.current.formRefArray.concat(r))}return F.current.formRefArray.map((t,o)=>{let{formRef:n}=t;return n.setInitialFormData(e[o]||{},r)})},[]),x=React.useCallback(function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[],r=arguments.length>1?arguments[1]:void 0;return F.current.formRefArray.map((t,o)=>{let{formRef:n}=t;return n.setFormErrors(e[o]||{},r)})},[]),w=React.useCallback(()=>F.current.formRefArray.map(e=>{let{formRef:r}=e;return r.getFormConfig()}),[]),k=React.useCallback(e=>{if(e){const r=F.current.formRefArray.find(r=>{let{formId:t}=r;return t===e});return r?r.formRef:null}return F.current.formRefArray.map(e=>{let{formRef:r}=e;return r})},[]),H=React.useCallback(()=>F.current.formRefArray.map(e=>{let{formRef:r}=e;return convertToOriginalData(r.getErrors())}),[]),q=React.useCallback(e=>F.current.formRefArray.map(r=>{let{formRef:t}=r;return t.resetForm(e)}),[]),D=React.useCallback(e=>F.current.formRefArray.map(r=>{let{formRef:t}=r;return t.clearForm(e)}),[]),G=React.useCallback(()=>F.current.formRefArray.length?F.current.formRefArray.map(e=>{let{formRef:r}=e;return r.getSampleForm()}):[],[]),Y=React.useCallback(e=>F.current.formRefArray.reduce((r,t)=>{let{formRef:o}=t;const n=o.validateForm(e);return{errorCount:r.errorCount+n.errorCount,isError:r.isError||n.isError,isValidatePassed:r.isValidatePassed||n.isValidatePassed,totalErrorCount:r.totalErrorCount+n.totalErrorCount,errors:r.errors.concat([n.errors]),values:r.values.concat([n.values])}},{errors:[],values:[],errorCount:0,totalErrorCount:0,isError:!1,isValidatePassed:!1}),[]);r&&"current"in r&&(r.current.formArray=y),R[IS_MULTIPLE].getValues=U,R[IS_MULTIPLE].getErrors=H,R[IS_MULTIPLE].validateForm=Y,R[IS_MULTIPLE].resetForm=q,R[IS_MULTIPLE].getSampleForm=G,R[IS_MULTIPLE].getFormConfig=w,R[IS_MULTIPLE].getFormRef=k,R[IS_MULTIPLE].setInitialFormData=N,R[IS_MULTIPLE].setFormErrors=x,R[IS_MULTIPLE].clearForm=D,R.getValues=U,R.getErrors=H,R.formRefArray=y,R.setFormValues=N,R.setInitialFormData=N,R.setFormErrors=x,R.getSampleForm=G,R.validateForm=Y,R.getFormConfig=w,R.getFormRef=k,R.resetForm=q,R.clearForm=D,R.count=y.length,R.setFormRefArray=v,R.values=U(),R.errors=H();const $={append:function(e){let r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],t=arguments.length>2?arguments[2]:void 0;return V(r,e,t,!0)},reset:M,clear:A,delete:j,clone:T,swap:b,move:O,insert:function(e){let r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],t=arguments.length>2?arguments[2]:void 0;return V(r,e,t)},prepend:function(e){let r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],t=arguments.length>2?arguments[2]:void 0;V(r,e,t)},formIds:P};R.formArrayProps=$,p._formRef.__formRef__.values=p._formRef.__formRef__.getValues(),p._formRef.__formRef__.errors=p._formRef.__formRef__.getErrors(),React.useEffect(()=>(R._ref(IS_FORMREF)._is_form_initiated=!0,R._renderForm(),R.renderForm(),()=>{R._ref(IS_FORMREF)._is_form_initiated=!1,R._renderForm(),R.renderForm()}),[R._formId_]),React.useEffect(()=>()=>{_.current.id&&(g.deleteFormConfig([_.current.id]),g.renderForm())},[g._formId_]),R._ref(IS_FORMREF)._setRenderForm||(R._ref(IS_FORMREF)._setRenderForm=c._setRenderForm),R&&R._formId_&&(R?R._ref(IS_FORMREF)._setInputProps=(e=>{g._renderInputProps&&g._renderInputProps(),C({})}):R._setInputProps=C);const K={ref:R,...R},B=(e,r)=>{const t={index:e,totalArrayCount:y.length,append:function(){let r=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[],t=arguments.length>1?arguments[1]:void 0;return V(r,P[e],t,!0)},reset:M.bind(null,P[e]),clear:A.bind(null,P[e]),delete:j.bind(null,P[e]),clone:T.bind(null,P[e]),swap:b.bind(null,P[e]),validate:r.validateForm,move:r=>O.bind(null,e,r),insert:function(e){let r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],t=arguments.length>2?arguments[2]:void 0;return V(r,e,t)},prepend:function(){let r=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[],t=arguments.length>1?arguments[1]:void 0;V(r,P[e],t)}};return{...t,form:t}};return React__default.createElement(FormContext.Provider,{value:{formId:g._formId_,setInputProps:m}},React__default.createElement(FormRefContext.Provider,{value:{formRef:R,formId:R._formId_,lastUpdated:R._lastUpdated,renderForm:d,setRefresh:h,rootFormRef:s||o}},n?"function"==typeof t?t(y,K):t:y.map((e,r)=>"function"==typeof t?t({...e,...B(r,e.formRef),index:r},K,r):t)))});const FormController=e=>{let{children:r,hide:t,render:o,inputConfig:n,...i}=e;return t?null:React__default.createElement(FormControllerContext.Provider,{value:{render:o,inputConfig:n,...i}},r)},emailRegex=/^([\w.+-]+@[a-zA-Z0-9.-]+\.[a-zA-z0-9]{2,4})$/;function validateEmail(e){return emailRegex.test(String(e).toLowerCase())}function validate(e,r){let{optional:t,minLength:o,isRequired:n,message:i={},length:a,pattern:u,key:c}=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};if((t||!n)&&!e)return"";const f="number"!=typeof e&&"boolean"!=typeof e&&!e;if(e&&o&&e.length<o)return i&&void 0!==i.minLength?i.minLength:`Minimum ${o} characters is required`;if(e&&a&&e.length!==a)return i&&i&&void 0!==i.length?i.length:`Number should be ${a} digits long`;switch(r){case"password":return f?i&&void 0!==i.required?i.required:"This field is required":"";case"email":return f?i&&void 0!==i.required?i.required:"Please enter your email":e&&!validateEmail(e)?i&&void 0!==i.invalid?i.invalid:"Invalid email address":"";case"name":return f?i&&void 0!==i.required?i.required:"Please enter your name":"";case"mobileNumber":return f?i&&void 0!==i.required?i.required:"Please enter 10 digit mobile number":"";case"about":return f?i&&void 0!==i.required?i.required:"This field is required":"";default:return f?i&&void 0!==i.required?i.required:"This field is required":u&&"[object RegExp]"===Object.prototype.toString.call(u)?u.test(e)?"":i&&void 0!==i.pattern?i.regex:`${c} is invalid `:""}}const formValidationHandler=function(){let{ON_CHANGE_KEY:e,ON_BLUR_KEY:r,VALUE_KEY:t,ERROR_KEY:o,VALIDATOR:n}=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},i=[],a={};const u=function(){let{VALIDATOR:c=n||validate,initialState:f={},getFormData:l,renderFormCallback:s=l,FORM_CONFIG:m={},ON_CHANGE_KEY:_=e||ON_CHANGE,ON_BLUR_KEY:d=r||ON_BLUR,VALUE_KEY:p=t||VALUE,ERROR_KEY:g=o||ERROR,[IS_MULTIPLE]:I,_formRef:R,_objKey:F="",_schemaKey:E,_initialErrors:C={},ref:h,_rootRef:y,_parentRef:v,_parentConfig:S,_parentId:P}=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};function O(){}const b={current:new O};O.prototype.is_validate_form_triggered=!1,O.prototype._schema={},O.prototype._formRef={},O.prototype._formIds=[];const M=R||b,A=e=>{deleteUniqueId(e),delete a[e];const r=M.current._formIds.filter(r=>r!==e);M.current._formIds=r,i=r};let L,V=_deepCopy(m);E||(V[IS_MULTIPLE]?(V={[IS_MULTIPLE]:V},L=IS_MULTIPLE):V[IS_SCHEMA]&&(V={[IS_SCHEMA]:V},L=IS_SCHEMA)),O.prototype._formConfig=_deepCopy(V);const T=I||L===IS_MULTIPLE;O.prototype._isMultipleForm=T,L&&(O.prototype._isSchema_or_isMultiple_config_is_root=L),O.prototype[IS_MULTIPLE]={_initialValues:T&&Array.isArray(f)?f.slice():[]},O.prototype._schema=b.current._schema;const j=e=>L?e[L]:e,U={initialValues:Array.isArray(f)?f.slice():newObject(f),Validate:c,getFormData:l,renderFormCallback:s,FORM_CONFIG:V,ON_CHANGE_KEY:_,ON_BLUR_KEY:d,VALUE_KEY:p,ERROR_KEY:g};O.prototype._initialFormConfig=U.FORM_CONFIG,O.prototype._initialConfig=U;const N=generateUniqueId();a[N]=b.current,i.push(N),M.current._formIds.push(N);let x=U.FORM_CONFIG;const w=function(e){let r=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},t=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},o=arguments.length>3?arguments[3]:void 0;const n=e||x;I&&e[IS_MULTIPLE]?O.prototype._multipleConfig=newObject(e):Object.entries(n).forEach(e=>{let[i,a]=e;if(o&&!o.includes(i))return;M.current._formRef.__formRef__||(M.current._formRef.__formRef__=b.current);const c=`${F?`${F}_`:""}${i}`;if((a[IS_SCHEMA]||a[IS_MULTIPLE])&&a[SCHEMA_CONFIG]||a._formId_){a[SCHEMA_CONFIG]?a[SCHEMA_CONFIG]=newObject(a[SCHEMA_CONFIG]):a._formId_&&(a._initialConfig=newObject(a._initialConfig),a._initialFormConfig=newObject(a._initialFormConfig));const e=b.current._schema[i]&&b.current._schema[i].formRef._formId_;e&&A(e);const o=u({...a._formId_?a._initialConfig:U,FORM_CONFIG:a._formId_?a._initialFormConfig:b.current._schema[i]&&b.current._schema[i].formRef.getFormConfig()||a[SCHEMA_CONFIG],ref:h,initialState:r[i]||f[i],_formRef:M,_objKey:c,_parentRef:b.current,_schemaKey:i,_parentConfig:n,_parentId:i,_initialErrors:t[i]||C[i],[IS_MULTIPLE]:a[IS_MULTIPLE]});b.current._hasChildRef=!0,b.current._schema[i]=o,M.current._formRef[c]=o}else o&&(H[i]=b.current._resetValue(i))})};w(x,f,C);const k=e=>r=>{const t=x[r]||{};return e?"default"in t?t.default:"":r in f?"function"==typeof f[r]?f[r]():f[r]:"default"in t?t.default:""};O.prototype._resetValue=k(!1),O.prototype._clearValue=k(!0);let H=_setInitialValues({formConfig:x,initialValues:f,formRef:b,isMultiple:I}),q=_setInitialErrors({formConfig:x,initialValues:C,formRef:b,isMultiple:I});O.prototype.formConfig=x;const D=e=>{if(M.current.getValues){b.current.values=b.current.getValues(),b.current.errors=b.current.getErrors(),O.prototype.formConfig=b.current.getFormConfig();const e=M.current.getValues(),r=M.current.getErrors(),t=M.current.getFormConfig();M.current.values=e,M.current.errors=r,M.current._ref(IS_FORMREF).formConfig=t,h&&"current"in h&&(h.current=h.current||{},h.current.values=e,h.current.errors=r,h.current.sampleFormObject=le())}"function"!==typeOf(l)||e||setTimeout(()=>{if(M.current.getValues){const e={values:(y||M).current.getValues(),errors:(y||M).current.getErrors(),formConfig:(y||M).current.getFormConfig()};isEqual(e,M.current.oldData)||(M.current.oldData=e,l(e))}})},G=function(e,r){let t=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];const o=_deepCopy(e);O.prototype._initialFormConfig=_deepCopy(e),O.prototype._formConfig=o,O.prototype.formConfig=o;const n=b.current.getValues(),i=b.current.getErrors();O.prototype.formConfig=_checkType(e,b.current.formConfig),x=o;const a=Math.floor(Math.random()*generateTimeStamp());var u;return b.current.lastUpdated=a,t&&(u=r,(Array.isArray(u)?u:Object.keys(u)).reduce((e,r)=>{const t=b.current._schema[r]&&b.current._schema[r].formRef,o=t&&t._formId_;return o&&A(o),delete b.current._schema[r],delete b.current._schema[r],{...e,[r]:{}}},{}),(e=>{(Array.isArray(e)?e:Object.keys(e)).forEach(e=>{const r=`${F?`${F}_`:""}${e}`;delete b.current._formRef[r]})})(r),w(e,newObject(n),newObject(i),r),D(!t),"function"===typeOf(b.current._setInputProps)&&b.current._setInputProps(b.current.getInputProps(b.current._extraProps||M.current._extraProps))),b.current},Y=(e,r)=>{b.current.values=_checkType(e,b.current.values),H=_checkType(e,H),D(),setTimeout(()=>{"function"!==typeOf(b.current._setInputProps)||r||b.current._setInputProps(b.current.getInputProps(b.current._extraProps||M.current._extraProps))})},$=(e,r)=>{b.current.errors=_checkType(e,b.current.errors),q=b.current.errors,D(),"function"!==typeOf(b.current._setInputProps)||r||b.current._setInputProps(b.current.getInputProps(b.current._extraProps||M.current._extraProps))},K=function(e,r,t,o,n){let i=arguments.length>5&&void 0!==arguments[5]&&arguments[5],a=arguments.length>6?arguments[6]:void 0;const u=n||b.current.formConfig[r]||{};let{value:f,error:l}=u&&u.validator?u.validator(e,{formRef:b.current,values:H,errors:q},u._config,u._commonInputProps):{value:e},s=null,m=null;if((u.allowOnlyNumber||u.min||u.max||"number"===u.type)&&Number.isNaN(+f)&&""!==f)return{error:s,value:f,key:r};if(u._noValidate||!u._initiated||"boolean"==typeof u.isValidateOnChange&&!u.isValidateOnChange?Y({...H,[r]:f},a):((void 0!==u.trim?u.trim:u.trim||i)&&(f=_trimStrings(f,u.isNumber)),u.maxLength&&(f||"").length>u.maxLength&&(m=void 0!==(u.message&&u.message.maxLength)?u.message.maxLength:`maximum ${u.maxLength} characters are allowed`),u&&(s=l||c(f,u.type,{key:r,optional:u.optional,minLength:u.minLength,message:u.message,maxLength:u.maxLength,length:u.length,...u})||m,f&&u.match&&"string"==typeof u.match&&H[u.match]&&(s=H[u.match]!==f?void 0!==(u.message&&u.message.match)?u.message.match:`${r} not matching with ${u.match}`:m)),r&&t&&(""!==f&&["string","number"].includes(typeof f)&&!Number.isNaN(+f)&&u.allowValidNumber&&!+f?s=void 0!==(u.message&&u.message.allowValidNumber)?u.message&&u.message.allowValidNumber:"Please enter valid number":u.allowOnlyNumber||u.min||u.max?Number.isNaN(+f)||""===f?f&&f.length?s=void 0!==(u.message&&u.message.allowOnlyNumber)?u.message&&u.message.allowOnlyNumber:"Only numbers are allowed":Y({...H,[r]:f},a):(f&&(u.min||u.max)&&(+f<u.min?s=void 0!==(u.message&&u.message.min)?u.message&&u.message.min:`Minimum value ${u.min} is required`:+f>u.max&&(s=void 0!==(u.message&&u.message.max)?u.message&&u.message.max:`Maximum value ${u.max} is allowed`)),Y({...H,[r]:f},a)):Y({...H,[r]:f},a))),"function"==typeof u.callback){const e=u.callback({error:s,value:f,key:r,formRef:b.current,values:H,errors:q,is_validation_allowed:!u._noValidate},b.current.formConfig[r]._config,b.current.formConfig[r]._commonInputProps);"object"===typeOf(e)&&(Y({...H,[r]:e.value},a),s=e.error)}return o&&$({...q,[r]:s||null},a),{error:s,value:f,key:r}},B=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},r=arguments.length>1?arguments[1]:void 0,{value:t,isStopPropagation:o,isValidateOnly:n,config:i,isSetError:a=!0,trim:u,dontRender:c}=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};e&&"function"==typeof e.preventDefault&&e.preventDefault(),e&&o&&"function"==typeof e.stopPropagation&&e.stopPropagation();let f=void 0!==t?t:_getPlatformBasedFieldValue(e);const l=_getPlatformBasedFieldName(e),s=r||l;if(n||!s)return K(f,s,null,null,i,u,c);K(f,s,!0,a,void 0,u,c)},z=function(e,r){let t=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};const o=_getPlatformBasedFieldName(e),n=r||o,i=H[n];(void 0===t.isValidateOnBlur||t.isValidateOnBlur)&&K(i,n,!1,!0)},J=e=>{let r=b.current.validateThisForm(e);return(r=Object.entries(b.current._schema).reduce((r,t)=>{let[o,n]=t;if(n.formRef._isMultipleForm&&!n.formRef[IS_MULTIPLE].validateForm)return r;let i=n.formRef[IS_MULTIPLE].validateForm?n.formRef[IS_MULTIPLE].validateForm(e):n.formRef.validateForm(e);return{errorCount:r.errorCount+i.errorCount,isError:r.isError||i.isError,isValidatePassed:r.isValidatePassed||i.isValidatePassed,totalErrorCount:r.totalErrorCount+i.totalErrorCount,errors:newObject(r.errors,{[o]:i.errors}),values:newObject(r.values,{[o]:i.values})}},r)).values=j(r.values),r.errors=j(r.errors),r},Z=e=>r=>{const t="function"==typeof r?r(b.current.getFormConfig()):r,o=Object.keys(r);return G(e?newObject(t):{...b.current.getFormConfig(),...t},o)},Q=e=>{const r={...x};Array.isArray(e)&&(e.forEach(e=>{"string"===typeOf(e)&&delete r[e]}),G(r,e))},W=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[],r=arguments.length>1?arguments[1]:void 0;e.forEach(e=>{H[e]&&B(H[e],e,r)})},X=function(e){let{config:r,propKeyMap:{onChange:t=_,onBlur:o=d,value:n=p,error:i=g}={},...a}=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};const u=b.current.formConfig[e],c=newObject(u._commonInputProps&&u._commonInputProps._defaultConfig||u);u&&(u._config={config:r,formId:N,key:e,keyName:e,lastUpdated:b.current.lastUpdated,...a},void 0===u._config.config&&delete u._config.config);let f={[t]:t=>{B(t,e,r);const o=u&&u.validateFieldsOnChange;o&&o.length>0&&W(o,u._config),u.render&&b.current.renderForm()},[o]:r=>z(r,e,u),[n]:H[e],[i]:q[e]};return(f={...f,...u&&("function"==typeof u.inputProps?u.inputProps(b.current,u._config,{onChange:f[t],onBlur:f[o],value:f[n],error:f[i],key:e}):u.inputProps)||{}}).inputProps={...f},f._fieldConfig=u,f._config={...b.current.formConfig[e]},f[IS_SCHEMA]={validateField:t=>{B(t,e,{...r,dontRender:!0});const o=r&&r.validateFieldsOnChange||u&&u.validateFieldsOnChange;o&&o.length>0&&W(o,{...u._config,dontRender:!0})}},f._defaultConfig=c,delete f._config.inputProps,delete f._config._commonInputProps,u&&(u._commonInputProps={...f}),f},ee=(e,r)=>{const t=e||{},o=Object.entries(b.current.formConfig).reduce((e,o)=>{let[n,i]=o;return i[IS_SCHEMA]||i._formId_||i[IS_MULTIPLE]?(b.current._schema[n].formRef.setInitialFormData(t[n],r),e):newObject(e,{[n]:n in t?t[n]:r?b.current._resetValue(n):t[n]})},{});Y(o)},re=e=>r=>{const t=Object.entries(x||{}).reduce((t,o)=>{let[n,i={}]=o;const a=e?"clearForm":"resetForm";return newObject(t,i[IS_SCHEMA]||i._formId_||i[IS_MULTIPLE]?r?{}:{[n]:i[IS_MULTIPLE]?(()=>{const e=b.current._schema[n].formRef[a]();return Array.isArray(e)?e:[]})():b.current._schema[n].formRef[a]()}:{[n]:e?b.current._clearValue(n):b.current._resetValue(n)})},H);return b.current.setFormValues(newObject(t),!0),b.current.setFormErrors({},!0),t},te=()=>oe(b.current._extraProps||M.current._extraProps),oe=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};return Object.entries(b.current.formConfig).reduce((r,t)=>{let[o,n]=t;return n[IS_SCHEMA]||n._formId_?r:{...r,[o]:X(o,e)}},{[IS_SCHEMA]:{addFormConfig:b.current.modifyFormConfig,deleteFormConfig:b.current.deleteFormConfig,getInputProps:te,onFormChangeCallback:D,resetFormInput:b.current.resetFormInput}})},ne=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},r={...x},t={...q};Object.entries(e).forEach(e=>{let[o,n]=e;r[o]._noValidate=!n,n||(t[o]=null)}),G(r,Object.keys(e)),$(t)},ie=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},r={...x},t={...q};Object.entries(e).forEach(e=>{let[o,n]=e;r[o].optional=n,r[o].isRequired=!1,t[o]=null}),G(r,Object.keys(e)),$(t),W(Object.keys(e))},ae=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},r={...x},t={...q};Object.entries(e).forEach(e=>{let[o,n]=e;r[o].isRequired=n,r[o].optional=!1,t[o]=null}),G(r,Object.keys(e)),$(t),W(Object.keys(e))},ue=()=>j(Object.entries(b.current.getFormConfig()).reduce((e,r)=>{let[t,o]=r;const n=o[IS_SCHEMA]||o._formId_||o[IS_MULTIPLE];if((!n&&!o._initiated||n&&(!b.current._schema[t]||!b.current._schema[t].formRef._is_form_initiated))&&!L)return e;if(!n&&!o._initiated)return e;let i=o[IS_MULTIPLE]?q[t]:b.current._schema[t]&&b.current._schema[t].formRef.getValues();const a=b.current._schema[t]&&b.current._schema[t].formRef[IS_MULTIPLE].getValues;return"function"==typeof a&&(i=a()),i=o[IS_MULTIPLE]?Array.isArray(i)?i:[]:i,{...e,[t]:n?i:void 0===H[t]?"default"in o?o.default:"":H[t]}},{})),ce=()=>j(Object.entries(x).reduce((e,r)=>{let[t,o]=r;const n=o[IS_SCHEMA]||o._formId_||o[IS_MULTIPLE];if((!n&&!o._initiated||n&&(!b.current._schema[t]||!b.current._schema[t].formRef._is_form_initiated))&&!L)return e;let i=o[IS_MULTIPLE]?q[t]:b.current._schema[t]&&b.current._schema[t].formRef.getErrors();const a=b.current._schema[t]&&b.current._schema[t].formRef[IS_MULTIPLE].getErrors;return"function"==typeof a&&(i=a()),{...e,[t]:n?o[IS_MULTIPLE]?Array.isArray(i)?i:[i]:i:q[t]||null}},{})),fe=()=>newObject(j(Object.entries(x).reduce((e,r)=>{let[t,o]=r;if(o[IS_SCHEMA]||o._formId_||o[IS_MULTIPLE]){let r=b.current._schema[t]&&b.current._schema[t].formRef.getFormConfig;return"function"==typeof r?{...e,[t]:{...o,[SCHEMA_CONFIG]:o[IS_MULTIPLE]&&b.current._schema[t]&&b.current._schema[t].formRef[IS_MULTIPLE].getFormConfig&&b.current._schema[t].formRef[IS_MULTIPLE].getFormConfig()||r()}}:e}return{...e,[t]:o}},{}))),le=()=>j(Object.entries(x).reduce((e,r)=>{let t,[o,n]=r;return t=n[IS_MULTIPLE]?b.current._schema[o]&&b.current._schema[o].formRef[IS_MULTIPLE].getSampleForm&&b.current._schema[o].formRef[IS_MULTIPLE].getSampleForm():b.current._schema[o]&&b.current._schema[o].formRef.getSampleForm(),{...e,[o]:n[IS_SCHEMA]||n._formId_||n[IS_MULTIPLE]?n[IS_MULTIPLE]?Array.isArray(t)?t:[t]:t:n.default}},{})),se=e=>{const r={...H},t={...q};(e||[]).forEach(e=>{const o=x[e];(o[IS_SCHEMA]||o[IS_MULTIPLE])&&o[SCHEMA_CONFIG]?r[e]=b.current._schema[e].formRef.resetForm():(r[e]=b.current._resetValue(e),t[e]=null)}),Y(r),$(t)},me=e=>{const r={...H},t={...q};(e||[]).forEach(e=>{const o=x[e];(o[IS_SCHEMA]||o[IS_MULTIPLE])&&o[SCHEMA_CONFIG]?r[e]=b.current._schema[e].formRef.clearForm():(r[e]=b.current._clearValue(e),t[e]=null)}),Y(r),$(t)};return b.current.getValues=ue,b.current.getErrors=ce,b.current.setFormValues=ee,b.current.setFormErrors=((e,r)=>{const t=Object.entries(b.current.formConfig).reduce((t,o)=>{let[n,i]=o;return i[IS_SCHEMA]||i._formId_||i[IS_MULTIPLE]?(b.current._schema[n].formRef.setFormErrors(e&&e[n]||{},r),t):newObject(t,{[n]:n in e||r?e[n]||null:q[n]})},{});$(t)}),b.current.getSampleForm=le,b.current.validateForm=J,b.current.resetForm=re(!1),b.current.clearForm=re(!0),b.current._isMultipleForm||(b.current.setValidate=ne,b.current.setOptional=ie,b.current.setRequired=ae,b.current.setOptional=ie,b.current.setRequired=ae,b.current.resetValues=se,b.current.clearValues=me,b.current.deleteFormConfig=Q,b.current.modifyFormConfig=Z(!1),b.current.resetFormConfig=Z(!0)),b.current.renderForm=(()=>{if("function"===typeOf(s)&&(y||M).current.getValues){const e={values:(y||M).current.getValues(),errors:(y||M).current.getErrors(),formConfig:(y||M).current.getFormConfig()};s(e)}}),b.current.getFormRef=(e=>{if(e&&e.length>0&&"array"===typeOf(e)){const r=b.current._formRef[e.join("_")];return r?r.formRef:null}return e?null:b.current._formRef.__formRef__}),b.current.getFormRefById=(e=>a[e]?a[e]:null),b.current._isRootRef=!R,v&&(O.prototype._parentRef=v),S&&(O.prototype._parentConfig=S),P&&(O.prototype._parentId=P),O.prototype._ref=(e=>e===IS_FORMREF?O.prototype:null),O.prototype.getInputProps=oe,O.prototype.getFormConfig=fe,O.prototype.commonInputProps=X,O.prototype.setInitialFormData=ee,O.prototype._renderForm=D,O.prototype.onBlurValues=z,O.prototype.onChangeValues=B,O.prototype.onValidateValues=(e=>{let{value:r,isValue:t,key:o,isValidateOnly:n,config:i,trim:a}=e;return B(r,o,{value:t?r:void 0,isValidateOnly:n,config:i,trim:a})}),O.prototype.validateThisForm=function(){let{isSetError:e=!0}=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};b.current.is_validate_form_triggered=!0;const r=b.current.getValues(),t=q,o=[];for(const[n,i]of Object.entries(x)){if(i[IS_SCHEMA]||i[IS_MULTIPLE]||i._formId_)continue;const{error:a}=K(r[n],n,!1,!1,i,!0);t[n]=a,a&&o.push(null),e&&$(t)}return b.current.is_validate_form_triggered=!1,{values:PRIMITIVE_VALUE in r?r[PRIMITIVE_VALUE]:r,errors:PRIMITIVE_VALUE in t?t[PRIMITIVE_VALUE]:t,totalErrorCount:o.length,errorCount:o.length,isError:o.length>0,isValidatePassed:0===o.length}},O.prototype.validateObject=((e,r)=>J({isSetError:!1,values:e,formConfig:r,isNewFormConfig:!0,isResetValue:!0,isResetError:!0})),O.prototype._onUnMountForm=(()=>{M.current._formIds.forEach(e=>{A(e),deleteUniqueId(e)})}),O.prototype.getSchema=(()=>newObject(j(Object.entries(x).reduce((e,r)=>{let[t,o]=r;if(o[IS_SCHEMA]||o._formId_||o[IS_MULTIPLE]){let r=b.current._schema[t]&&b.current._schema[t].formRef.getSchema;return"function"==typeof r?{...e,[t]:{...o,[SCHEMA_CONFIG]:r()}}:e}return{...e,[t]:o}},{})))),O.prototype.setFormConfig=G,O.prototype.resetFormInput=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:[],r=arguments.length>1?arguments[1]:void 0;const t={...H},o={...q};e.forEach(e=>{r&&!e in f?(delete t[e],delete o[e]):(t[e]=b.current._resetValue(e),o[e]=null)}),Y(t),$(o)},O.prototype.validateCustomForm=(e=>{let{isSetError:r,formConfig:t={},values:o={},errors:n={}}=e;const i=t,a=o,u=n,c=[];for(const e of Object.keys(i)){const{error:r}=K(a[e],e,!1,!1,i[e]);u[e]=r,r&&c.push(null)}return r&&$(u),{values:a,errors:u,totalErrorCount:c.length,errorCount:c.length,isError:c.length>0,isValidatePassed:0===c.length}}),O.prototype.getFormConfig=fe,O.prototype._objKey=F,O.prototype._schema=b.current._schema,O.prototype._formValidationHandler=u,O.prototype.formConfig=newObject(b.current._formConfig),O.prototype._renderInputProps=(()=>{"function"===typeOf(b.current._setInputProps)&&b.current._setInputProps(b.current.getInputProps(b.current._extraProps||M.current._extraProps))}),O.prototype._formId_=N,b.current.formId=N,O.prototype._ref=(e=>e===IS_FORMREF?O.prototype:null),b.current.values=ue(),b.current.errors=ce(),D(),{formRef:b.current,formId:N}};return{useForm:e=>{let{renderForm:r,...t}=e;const o=React.useState()[1],[{formRef:n,formId:i}]=React.useState(()=>u({...t,renderFormCallback:o,getFormData:r?o:void 0}));return n._ref(IS_FORMREF)._setRenderForm=o,n._ref(IS_FORMREF)._isRenderForm=r,React.useEffect(()=>n._onUnMountForm,[n]),{formRef:n,formId:i}},formHandler:u,useFormRef:e=>{const{formRef:r,rootFormRef:t}=React.useContext(FormRefContext)||{},o=e?a[e]:r;return o?{formRef:o,formId:o&&o._formId_,rootFormRef:t||o}:{}}}},FormProvider$1=formValidationHandler,Form={Consumer:FormConsumer,Provider:FormProvider,Controller:FormController,Multiple:MultipleFormProvider};exports.Form=Form,exports.FormProvider=FormProvider$1;
